#include <bits/stdc++.h>
using namespace std;



void Preracunaj(int*a,int*b,int n, int red)
{
	int zadnjiaktivan =-1;
	int zasledeciaktivan=0;

	for(int i=0;i<n;i++)
	{
		if (b[i]==0)
		{
			int ostatak=a[i]%2;
			int pola=a[i]/2;

			zasledeciaktivan=zasledeciaktivan+pola;
			if (zadnjiaktivan>=0)
				a[zadnjiaktivan]=a[zadnjiaktivan]+pola;
			else
				zasledeciaktivan=zasledeciaktivan+pola;

			if (red==1 && zadnjiaktivan>=0)
				a[zadnjiaktivan]=a[zadnjiaktivan]+ostatak;
			else
				zasledeciaktivan=zasledeciaktivan+ostatak;


			a[i]=0;

		}
		else
		{

			a[i]=a[i]+ zasledeciaktivan;
			zasledeciaktivan=0;
			zadnjiaktivan=i;
		}

	}
	a[zadnjiaktivan]=a[zadnjiaktivan]+zasledeciaktivan;
}


int main()
{
ios_base::sync_with_stdio(false);
cin.tie(NULL);	
	int h, n;
	std::cin>>h>>n;

	int*a=new int[n];
	int *b=new int[n];

	for(int i=0;i<n;i++)
		a[i]=1;

	for(int i=0;i<h;i++)
	{
		for(int j=0;j<n;j++)
		std::cin>>b[j];
		Preracunaj(a,b,n,(i+1)%2);

	}


	for(int i=0;i<n;i++)
		std::cout<<a[i];

	return 0;
}